
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "qpid/agent/ManagementAgent.h"
#include "Host.h"


using namespace qmf::com::redhat::matahari::host;
using namespace qpid::framing;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           std::string;

string  Host::packageName  = string ("com.redhat.matahari.host");
string  Host::className    = string ("host");
uint8_t Host::md5Sum[16]   =
    {0x82,0xe4,0x15,0x93,0x16,0x72,0x66,0xd6,0x3,0x2d,0x53,0x3f,0x12,0xd0,0x6e,0xf7};

Host::Host (ManagementAgent*, Manageable* _core) :
    ManagementObject(_core)
{
    
    uuid = "";
    hostname = "";
    is_virtual = 0;
    operating_system = "";
    memory = 0;
    arch = "";
    hypervisor = "";
    platform = 0;
    processors = 0;
    cores = 0;
    model = "";
    last_updated_seq = 0;
    last_updated = 0;
    load_average_1 = 0.;
    load_average_5 = 0.;
    load_average_15 = 0.;



}

Host::~Host ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Host::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Host::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (11); // Config Element Count
    buf.putShort       (5); // Inst Element Count
    buf.putShort       (3); // Method Count

    // Properties
    ft.clear();
    ft.setString (NAME, "uuid");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Host UUID");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "hostname");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Hostname");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "is_virtual");
    ft.setInt    (TYPE, TYPE_BOOL);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Is this machine virtual?");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "operating_system");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The installed operating system.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "memory");
    ft.setInt    (TYPE, TYPE_S64);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "kb");
    ft.setString (DESC,   "Amount of primary memory for host (kb)");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "arch");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Architecture of host");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "hypervisor");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Hypervisor used by host");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "platform");
    ft.setInt    (TYPE, TYPE_U8);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "bit");
    ft.setString (DESC,   "The wordsize for the host.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "processors");
    ft.setInt    (TYPE, TYPE_U8);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The number of physical CPUs.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "cores");
    ft.setInt    (TYPE, TYPE_U8);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The total number of processor cores.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "model");
    ft.setInt    (TYPE, TYPE_LSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "The processor(s) model description.");
    buf.put (ft);


    // Statistics
    ft.clear();
    ft.setString (NAME,   "last_updated_seq");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (DESC,   "The heartbeat sequence number.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "last_updated");
    ft.setInt    (TYPE,   TYPE_ABSTIME);
    ft.setString (DESC,   "The last time a heartbeat occurred.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "load_average_1");
    ft.setInt    (TYPE,   TYPE_DOUBLE);
    ft.setString (DESC,   "The one minute load average.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "load_average_5");
    ft.setInt    (TYPE,   TYPE_DOUBLE);
    ft.setString (DESC,   "The five minute load average.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "load_average_15");
    ft.setInt    (TYPE,   TYPE_DOUBLE);
    ft.setString (DESC,   "The fiften minute load average");
    buf.put (ft);


    // Methods
    ft.clear();
    ft.setString (NAME,     "identify");
    ft.setInt    (ARGCOUNT, 0);
    ft.setString (DESC,     "Tells the host to beep its pc speaker.");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "shutdown");
    ft.setInt    (ARGCOUNT, 0);
    ft.setString (DESC,     "Shutdown node");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "reboot");
    ft.setInt    (ARGCOUNT, 0);
    ft.setString (DESC,     "Reboot node");
    buf.put (ft);


}



void Host::writeProperties (Buffer& buf)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);

    buf.putShortString(uuid);
    buf.putShortString(hostname);
    buf.putOctet(is_virtual?1:0);
    buf.putShortString(operating_system);
    buf.putInt64(memory);
    buf.putShortString(arch);
    buf.putShortString(hypervisor);
    buf.putOctet(platform);
    buf.putOctet(processors);
    buf.putOctet(cores);
    buf.putMediumString(model);

}

void Host::writeStatistics (Buffer& buf, bool skipHeaders)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders)
        writeTimestamps (buf);
    buf.putLong(last_updated_seq);
    buf.putLongLong(last_updated);
    buf.putDouble(load_average_1);
    buf.putDouble(load_average_5);
    buf.putDouble(load_average_15);


    // Maintenance of hi-lo statistics


}

void Host::doMethod (string& methodName, Buffer&, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "identify") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_IDENTIFY, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "shutdown") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_SHUTDOWN, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "reboot") {
        ::qpid::management::ArgsNone ioArgs;
        status = coreObject->ManagementMethod (METHOD_REBOOT, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    outBuf.putLong(status);
    outBuf.putShortString(Manageable::StatusText(status, text));
}
