
#ifndef _MANAGEMENT_HOST_
#define _MANAGEMENT_HOST_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/Uuid.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace com {
namespace redhat {
namespace matahari {
namespace host {


class Host : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[16];


    // Properties
    std::string uuid;
    std::string hostname;
    uint8_t is_virtual;
    std::string operating_system;
    int64_t memory;
    std::string arch;
    std::string hypervisor;
    uint8_t platform;
    uint8_t processors;
    uint8_t cores;
    std::string model;

    // Statistics
    uint32_t  last_updated_seq;
    int64_t  last_updated;
    double  load_average_1;
    double  load_average_5;
    double  load_average_15;


    // Private Methods
    static void writeSchema(::qpid::framing::Buffer& buf);
    void writeProperties(::qpid::framing::Buffer& buf);
    void writeStatistics(::qpid::framing::Buffer& buf,
                         bool skipHeaders = false);
    void doMethod(std::string& methodName,
                  ::qpid::framing::Buffer& inBuf,
                  ::qpid::framing::Buffer& outBuf);
    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }

  public:

    Host(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject);
    ~Host();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_IDENTIFY = 1;
    static const uint32_t METHOD_SHUTDOWN = 2;
    static const uint32_t METHOD_REBOOT = 3;

    // Accessor Methods
    inline void set_uuid (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        uuid = val;
        configChanged = true;
    }
    inline const std::string& get_uuid() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return uuid;
    }
    inline void set_hostname (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        hostname = val;
        configChanged = true;
    }
    inline const std::string& get_hostname() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return hostname;
    }
    inline void set_is_virtual (uint8_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        is_virtual = val;
        configChanged = true;
    }
    inline uint8_t get_is_virtual() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return is_virtual;
    }
    inline void set_operating_system (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        operating_system = val;
        configChanged = true;
    }
    inline const std::string& get_operating_system() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return operating_system;
    }
    inline void set_memory (int64_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        memory = val;
        configChanged = true;
    }
    inline int64_t get_memory() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return memory;
    }
    inline void set_arch (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        arch = val;
        configChanged = true;
    }
    inline const std::string& get_arch() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return arch;
    }
    inline void set_hypervisor (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        hypervisor = val;
        configChanged = true;
    }
    inline const std::string& get_hypervisor() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return hypervisor;
    }
    inline void set_platform (uint8_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        platform = val;
        configChanged = true;
    }
    inline uint8_t get_platform() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return platform;
    }
    inline void set_processors (uint8_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        processors = val;
        configChanged = true;
    }
    inline uint8_t get_processors() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return processors;
    }
    inline void set_cores (uint8_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        cores = val;
        configChanged = true;
    }
    inline uint8_t get_cores() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return cores;
    }
    inline void set_model (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        model = val;
        configChanged = true;
    }
    inline const std::string& get_model() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return model;
    }
    inline void set_last_updated_seq (uint32_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        last_updated_seq = val;
        instChanged = true;
    }
    inline uint32_t get_last_updated_seq() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return last_updated_seq;
    }
    inline void set_last_updated (int64_t val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        last_updated = val;
        instChanged = true;
    }
    inline int64_t get_last_updated() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return last_updated;
    }
    inline void set_load_average_1 (double val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        load_average_1 = val;
        instChanged = true;
    }
    inline double get_load_average_1() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return load_average_1;
    }
    inline void set_load_average_5 (double val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        load_average_5 = val;
        instChanged = true;
    }
    inline double get_load_average_5() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return load_average_5;
    }
    inline void set_load_average_15 (double val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        load_average_15 = val;
        instChanged = true;
    }
    inline double get_load_average_15() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return load_average_15;
    }

};

}}}}}

#endif  /*!_MANAGEMENT_HOST_*/
