
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "qpid/agent/ManagementAgent.h"
#include "Network.h"
#include "ArgsNetworkList.h"
#include "ArgsNetworkDestroy.h"
#include "ArgsNetworkStart.h"
#include "ArgsNetworkStop.h"
#include "ArgsNetworkStatus.h"
#include "ArgsNetworkDescribe.h"


using namespace qmf::com::redhat::matahari::net;
using namespace qpid::framing;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           std::string;

string  Network::packageName  = string ("com.redhat.matahari.net");
string  Network::className    = string ("network");
uint8_t Network::md5Sum[16]   =
    {0xe9,0x5b,0xae,0xee,0xa8,0xd6,0xe8,0x36,0x2,0x9b,0x71,0xe1,0x87,0xa4,0xd9,0xc7};

Network::Network (ManagementAgent*, Manageable* _core) :
    ManagementObject(_core)
{
    
    hostname = "";



}

Network::~Network ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Network::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Network::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (1); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (6); // Method Count

    // Properties
    ft.clear();
    ft.setString (NAME, "hostname");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Hostname");
    buf.put (ft);


    // Statistics

    // Methods
    ft.clear();
    ft.setString (NAME,     "list");
    ft.setInt    (ARGCOUNT, 2);
    ft.setString (DESC,     "List IP addresses");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "max");
    ft.setInt    (TYPE,    TYPE_U32);
    ft.setString (DIR,     "O");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "iface_map");
    ft.setInt    (TYPE,    TYPE_FTABLE);
    ft.setString (DIR,     "O");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "destroy");
    ft.setInt    (ARGCOUNT, 1);
    ft.setString (DESC,     "Remove network interface");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "iface");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "start");
    ft.setInt    (ARGCOUNT, 2);
    ft.setString (DESC,     "Start a network interface");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "iface");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "status");
    ft.setInt    (TYPE,    TYPE_U32);
    ft.setString (DIR,     "O");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "stop");
    ft.setInt    (ARGCOUNT, 2);
    ft.setString (DESC,     "Stop a network interface");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "iface");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "status");
    ft.setInt    (TYPE,    TYPE_U32);
    ft.setString (DIR,     "O");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "status");
    ft.setInt    (ARGCOUNT, 2);
    ft.setString (DESC,     "Check a network interface");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "iface");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "status");
    ft.setInt    (TYPE,    TYPE_U32);
    ft.setString (DIR,     "O");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,     "describe");
    ft.setInt    (ARGCOUNT, 2);
    ft.setString (DESC,     "Obtain XML description of a network interface status");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "iface");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "I");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "xml");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DIR,     "O");
    buf.put (ft);


}



void Network::writeProperties (Buffer& buf)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);

    buf.putShortString(hostname);

}

void Network::writeStatistics (Buffer& buf, bool skipHeaders)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders)
        writeTimestamps (buf);


    // Maintenance of hi-lo statistics


}

void Network::doMethod (string& methodName, Buffer& inBuf, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "list") {
        ArgsNetworkList ioArgs;
        status = coreObject->ManagementMethod (METHOD_LIST, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        outBuf.putLong(ioArgs.o_max);
        ioArgs.o_iface_map.encode(outBuf);
        return;
    }

    if (methodName == "destroy") {
        ArgsNetworkDestroy ioArgs;
        inBuf.getShortString(ioArgs.i_iface);
        status = coreObject->ManagementMethod (METHOD_DESTROY, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        return;
    }

    if (methodName == "start") {
        ArgsNetworkStart ioArgs;
        inBuf.getShortString(ioArgs.i_iface);
        status = coreObject->ManagementMethod (METHOD_START, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        outBuf.putLong(ioArgs.o_status);
        return;
    }

    if (methodName == "stop") {
        ArgsNetworkStop ioArgs;
        inBuf.getShortString(ioArgs.i_iface);
        status = coreObject->ManagementMethod (METHOD_STOP, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        outBuf.putLong(ioArgs.o_status);
        return;
    }

    if (methodName == "status") {
        ArgsNetworkStatus ioArgs;
        inBuf.getShortString(ioArgs.i_iface);
        status = coreObject->ManagementMethod (METHOD_STATUS, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        outBuf.putLong(ioArgs.o_status);
        return;
    }

    if (methodName == "describe") {
        ArgsNetworkDescribe ioArgs;
        inBuf.getShortString(ioArgs.i_iface);
        status = coreObject->ManagementMethod (METHOD_DESCRIBE, ioArgs, text);
        outBuf.putLong        (status);
        outBuf.putMediumString(::qpid::management::Manageable::StatusText (status, text));
        outBuf.putShortString(ioArgs.o_xml);
        return;
    }

    outBuf.putLong(status);
    outBuf.putShortString(Manageable::StatusText(status, text));
}
