
#ifndef _MANAGEMENT_NETWORK_
#define _MANAGEMENT_NETWORK_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/framing/Uuid.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace com {
namespace redhat {
namespace matahari {
namespace net {


class Network : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[16];


    // Properties
    std::string hostname;

    // Statistics


    // Private Methods
    static void writeSchema(::qpid::framing::Buffer& buf);
    void writeProperties(::qpid::framing::Buffer& buf);
    void writeStatistics(::qpid::framing::Buffer& buf,
                         bool skipHeaders = false);
    void doMethod(std::string& methodName,
                  ::qpid::framing::Buffer& inBuf,
                  ::qpid::framing::Buffer& outBuf);
    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }

    // Stub for getInstChanged.  There are no statistics in this class.
    bool getInstChanged() { return false; }
    bool hasInst() { return false; }

  public:

    Network(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject);
    ~Network();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_LIST = 1;
    static const uint32_t METHOD_DESTROY = 2;
    static const uint32_t METHOD_START = 3;
    static const uint32_t METHOD_STOP = 4;
    static const uint32_t METHOD_STATUS = 5;
    static const uint32_t METHOD_DESCRIBE = 6;

    // Accessor Methods
    inline void set_hostname (const std::string& val) {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        hostname = val;
        configChanged = true;
    }
    inline const std::string& get_hostname() {
        ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
        return hostname;
    }

};

}}}}}

#endif  /*!_MANAGEMENT_NETWORK_*/
